;(function(){

/////////////////////////////////////
// var
// 
	var _VERBOSE = false;//set in C2_VARS
	var C2FUNC = {
		updateBoss			: "updateBoss",
		bossMakeAction		: "bossMakeAction",
		getJsonPlayer		: "getJsonPlayer",
		getJsonBoss			: "getJsonBoss",
		playerDoAction		: "playerDoAction",
		resetPosBoss6		: "BOSS6_resetPosBoss",
		createClone			: "BOSS8_createClone",
		bossMakeActionCenter: "BOSS8_makeActionWithCenter",
		nextMove			: "BOSS8_nextMove",
		dCloneMoveMid		: "BOSS8_destroyCloneAndMoveToMid",
		isOnMove			: "BOSS8_isOnMove"
	};

	var RANGE_KO= [
		[1,3],
		[2,4],
		[5,8],
		[8,9],
		[10,10]
	];

	var DIR_CAPA = {
		left	: "left",
		right	: "right",
		none	: "none"
	}

	var LIST_CAPA_BOXER = {
		idle			: "idle",
		dodge			: "dodge",
		block			: "block",
		afterBlock		: "afterBlock",
		blockUp			: "blockUp",
		blockDown		: "blockDown",
		punchHead		: "punchHead",
		punchChest		: "punchChest",
		punchDodge		: "punchDodge",
		preSuper		: "preSuper",
		super			: "super",
		hittedHead		: "hittedHead",
		hittedChest		: "hittedChest",
		nothing			: "nothing",
		specific		: "specific",
		hitByPunch		: function(action){
			switch(action){
				case this.punchDodge:
				case this.super:
				case this.punchHead:
					return this.hittedHead;
				case this.punchChest:
					return this.hittedChest;
				default:
					return this.nothing;
			}
		}
	}
/////////////////////////////////////

/////////////////////////////////////
// GAME gameMain
	var gameMain = function(){};
	gameMain.prototype.lvl_info = {};
	gameMain.prototype.isInit = false;
	gameMain.prototype.boss;

	gameMain.prototype.init = function(info_lvl,verbose){
		_VERBOSE = (verbose)?true:false;
		if(this.isInit){return;}
		this.lvl_info = info_lvl;
		if(_VERBOSE) console.log(this.lvl_info);
		this.boss = new Boss().create(this,this.lvl_info.strat);
		this.playerKoCount = 0;

		this.isInit = true;
	};

	gameMain.prototype.end = function() {
		this.isInit = false;
		delete this.boss;
	};

	gameMain.prototype.userMakeAction = function(action,dir) {
		var actionBack = this.boss.userMakeAction(action, dir);
		var player = JSON.parse(c2_callFunction(C2FUNC.getJsonPlayer));
		var actionHit = LIST_CAPA_BOXER.hitByPunch(actionBack);
		if(actionHit != LIST_CAPA_BOXER.nothing && player.animationName != LIST_CAPA_BOXER.dodge && player.animationName != LIST_CAPA_BOXER.block ){
			c2_callFunction(C2FUNC.playerDoAction,[actionHit]);
		}
	};

	gameMain.prototype.actionEnd = function(action,dir,isRealBoxer) {
		this.boss.actionEnd(action,dir,(isRealBoxer)?true:false);
		this.playerCheckActionToDoActionEnd(action);
	};

	gameMain.prototype.update = function(dt) {
		this.boss.update(dt);
	};

	gameMain.prototype.onKo = function(isBoss) {
		if(!isBoss){this.playerKoCount++;}
		this.boss.onKo(isBoss);
	};

	gameMain.prototype.getStarsToCreate = function(isBoss) {
		var koCount = (isBoss)?this.boss.koCount:this.playerKoCount;
		if(_VERBOSE) console.log("koCount",koCount,isBoss);
		var range = (koCount >= RANGE_KO.length)?RANGE_KO[RANGE_KO.length-1]:RANGE_KO[koCount];
		return randomIntFromInterval(range[0], range[1]);
	};

	gameMain.prototype.playerCheckActionToDoActionEnd = function(action) {
	};

	gameMain.prototype.playerCheckActionToDoOnHit = function(action,bossDir,playerDir) {
		var player = JSON.parse(c2_callFunction(C2FUNC.getJsonPlayer));
		var actionHit = LIST_CAPA_BOXER.hitByPunch(action);
		if(_VERBOSE) console.log("playerCheckActionToDoOnHit",arguments);
		if(player.animationName == LIST_CAPA_BOXER.dodge && (!this.lvl_info["dodgeSided_"+action] || bossDir == playerDir)){
			this.boss.playerDodgeHit(action);
		}
		else if(player.animationName == LIST_CAPA_BOXER.block && this.lvl_info["canBlock_"+action]){
			c2_callFunction(C2FUNC.playerDoAction,[LIST_CAPA_BOXER.afterBlock]);
			this.boss.playerBlockHit(action);
		}
		else if(actionHit != LIST_CAPA_BOXER.nothing){
			c2_callFunction(C2FUNC.playerDoAction,[actionHit]);
		}
	};

	gameMain.prototype.endRound = function() {
		this.boss.endRound();
	};
/////////////////////////////////////

/////////////////////////////////////
// Boss
	var Boss = function(){};
	Boss.id = 0;
	Boss.prototype.waitAction = [];
	Boss.prototype.koCount;
	Boss.prototype.create = function(gameMain,strat) {
		this.gameMain = gameMain;
		this.id = Boss.id++;
		this.strat = strat;
		this.koCount = 0;
		this.getActualStrat().prepare();
		return this;
	};

	Boss.prototype.nextAction = function() {
		if(this.waitAction.length == 0) return;
		var action = this.waitAction.shift();
	};

	Boss.prototype.getActualStrat = function() {
		return StratManager.getStratByName(this.strat);
	};

	Boss.prototype.userMakeAction = function(action,dir) {
		var actionBack = this.getActualStrat().userMakeAction(action,dir,this);
		if(actionBack != LIST_CAPA_BOXER.nothing){ 
			this.makeAction(actionBack);
		}
		return actionBack;
	};

	Boss.prototype.getJsonBoss = function(){
		return JSON.parse(c2_callFunction(C2FUNC.getJsonBoss));
	}

	Boss.prototype.actionEnd = function(action,dir,isRealBoxer) {
		return this.getActualStrat().actionEnd(action,this,dir,isRealBoxer);
	};

	Boss.prototype.playerDodgeHit = function(action){
		return this.getActualStrat().playerDodgeHit(action,this);
	};

	Boss.prototype.playerBlockHit = function(action){
		return this.getActualStrat().playerBlockHit(action,this);
	};

	Boss.prototype.update = function(dt) {
		return this.getActualStrat().update(dt,this);
	};

	Boss.prototype.onKo = function(isBoss) {
		if(isBoss) this.koCount ++;
		this.makeAction(LIST_CAPA_BOXER.idle);
		if(typeof(this.getActualStrat().onKo) == "function") this.getActualStrat().onKo(isBoss);
	};

	Boss.prototype.endRound = function() {
		if(typeof(this.getActualStrat().endRound) == "function") this.getActualStrat().endRound();
	};

	Boss.prototype.updateInC2 = function() {
		c2_callFunction(C2FUNC.updateBoss);
	};

	Boss.prototype.makeAction = function(action) {
		if(_VERBOSE) console.log("action",action);
		c2_callFunction(C2FUNC.bossMakeAction,[action]);
	};
/////////////////////////////////////

/////////////////////////////////////
// Strat
	var StratManager = {};
	StratManager.listStrat = {};
	StratManager.getStratByName = function(name) {
		try{
			return this.listStrat[name];
		}catch(e){
			if(_VERBOSE) console.log("stratName not defined");
			return {};
		}
	};

	StratManager.registerStrat = function(strat,stratName) {
		this.listStrat[stratName] = strat;
		if(_VERBOSE) console.log("Init ",stratName);
	}

	////////////////////////////////////////
	// block 50% bottom or top
		var block50 = {};
		block50.MAX_HITTED = 3;
		block50.MAX_BLOCKED = 3;
		block50.TIMER_BETWEEN_HIT_MAX = 8;
		block50.TIMER_BETWEEN_HIT_MIN = 3;

		block50.init = function() {
			StratManager.registerStrat(block50,"block50");
		};

		block50.prepare = function(){
			this.changeChoosen();
			this.setNewTimerHit();
		};

		block50.changeChoosen = function(){
			this.choosenBlock = [LIST_CAPA_BOXER.punchHead,LIST_CAPA_BOXER.punchChest][Math.floor(Math.random()*2)];
			this.countHitted = 0;
			this.countBlocked = 0;
		};

		block50.setNewTimerHit = function(){
			this.nextHit = (Math.random() * (this.TIMER_BETWEEN_HIT_MAX - this.TIMER_BETWEEN_HIT_MIN)) + this.TIMER_BETWEEN_HIT_MIN;
		};

		block50.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.super){ return actionBack; }
			if(this.choosenBlock == action){
				actionBack = LIST_CAPA_BOXER.block;
			}
			else if(action == LIST_CAPA_BOXER.punchDodge && (Math.random()*100) < 50){
				actionBack = LIST_CAPA_BOXER.block;
			}
			else if(this.countHitted > this.MAX_HITTED){
				this.changeChoosen();
				actionBack = LIST_CAPA_BOXER.block;
			}else{
				actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}

			if(actionBack != LIST_CAPA_BOXER.nothing && actionBack != LIST_CAPA_BOXER.block){ this.countHitted ++;}
			if(actionBack == LIST_CAPA_BOXER.block){ this.countBlocked++}
			else{this.countBlocked = 0;}

			if(this.countBlocked > this.MAX_BLOCKED){
				this.countBlocked = 0;
				actionBack = LIST_CAPA_BOXER.preSuper;
			}
			
			return actionBack;
		};

		block50.actionEnd = function(action,boss) {
			if(action == LIST_CAPA_BOXER.preSuper){
				var player = JSON.parse(c2_callFunction(C2FUNC.getJsonPlayer));
				var actionHit = LIST_CAPA_BOXER.hitByPunch(LIST_CAPA_BOXER.super);
				if(actionHit != LIST_CAPA_BOXER.nothing && player.animationName != LIST_CAPA_BOXER.dodge /*&& player.animationName != LIST_CAPA_BOXER.block*/ ){
					boss.makeAction(LIST_CAPA_BOXER.super);
				}else{
					boss.makeAction(LIST_CAPA_BOXER.idle);
				}
			}
		};

		block50.update = function(dt,boss) {
			this.nextHit -= dt;

			if(this.nextHit <= 0){
				this.setNewTimerHit();
				var bossJson = boss.getJsonBoss();
				if(bossJson.animationName == LIST_CAPA_BOXER.idle){ 
					boss.makeAction(LIST_CAPA_BOXER.punchHead);
				}
			}
		};

		block50.playerDodgeHit = function(action){};

		block50.playerBlockHit = function(action){};

		block50.init();
	/////////////////////////////////////
	
	////////////////////////////////////////
	// dodge every attack and take domage only after launch hit
		var dodgeAll = {};
		dodgeAll.VULNERABLE_TIME = 3;//second
		dodgeAll.MAX_DODGED = 3;
		dodgeAll.TIMER_BETWEEN_HIT_MAX = 8;
		dodgeAll.TIMER_BETWEEN_HIT_MIN = 3;


		dodgeAll.init = function() {
			StratManager.registerStrat(dodgeAll,"dodgeAll");
		};

		dodgeAll.prepare = function(){
			this.setNewTimerHit();
			this.vulnerableTimeCount = this.VULNERABLE_TIME/2;
			this.countDodged = 0;
		};

		dodgeAll.setNewTimerHit = function(){
			this.nextHit = (Math.random() * (this.TIMER_BETWEEN_HIT_MAX - this.TIMER_BETWEEN_HIT_MIN)) + this.TIMER_BETWEEN_HIT_MIN;
		};

		dodgeAll.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }

			if(this.vulnerableTimeCount <= 0 &&
			  (action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.super)){
				actionBack = LIST_CAPA_BOXER.dodge;
				this.countDodged ++;
			}else{
				actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}

			if(this.countDodged > this.MAX_DODGED){
				this.countDodged = 0;
				actionBack = LIST_CAPA_BOXER.preSuper;
				this.setNewTimerHit();
			}
			return actionBack;
		};

		dodgeAll.actionEnd = function(action,boss) {
			if(action == LIST_CAPA_BOXER.preSuper){
				var player = JSON.parse(c2_callFunction(C2FUNC.getJsonPlayer));
				var actionHit = LIST_CAPA_BOXER.hitByPunch(LIST_CAPA_BOXER.super);
				if(actionHit != LIST_CAPA_BOXER.nothing && player.animationName != LIST_CAPA_BOXER.dodge /*&& player.animationName != LIST_CAPA_BOXER.block*/ ){
					boss.makeAction(LIST_CAPA_BOXER.super);
					this.setNewTimerHit();
				}else{
					boss.makeAction(LIST_CAPA_BOXER.idle);
				}
			}
		};

		dodgeAll.update = function(dt,boss) {
			this.nextHit -= dt;
			this.vulnerableTimeCount -= dt;

			if(this.nextHit <= 0){
				this.setNewTimerHit();
				boss.makeAction((Math.random()>0.5)?LIST_CAPA_BOXER.punchChest:LIST_CAPA_BOXER.punchHead);
			}

			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
				if(boss.getJsonBoss().animationName == LIST_CAPA_BOXER.specific){
					boss.makeAction(LIST_CAPA_BOXER.idle);
				}
			}
		};

		dodgeAll.playerDodgeHit = function(action,boss){
			if(action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchHead){
				this.vulnerableTimeCount = this.VULNERABLE_TIME;
				boss.makeAction(LIST_CAPA_BOXER.specific);
			}
		};

		dodgeAll.playerBlockHit = function(action){};

		dodgeAll.init();
	/////////////////////////////////////
	
	////////////////////////////////////////
	// Boss3
		/*
		block son enchainement de coup 4-6 <<<<< coup chest >>>>>
		eviter sont coup charger d'un coté (avec une esquive seulement) : <<<<< coup super >>>>>
		frapper pendant x coup (apres l'enchainement)
		si il prend un coup : <<<<< dodge puis remet un coup direct (head) >>>>>
		*/
		var boss3 = {};
		boss3.VULNERABLE_TIME = 4;//second
		boss3.TIMER_BETWEEN_HIT_MAX = 4;
		boss3.TIMER_BETWEEN_HIT_MIN = 2;
		boss3.MAX_HIT = 6;
		boss3.MIN_HIT = 4;


		boss3.init = function() {
			StratManager.registerStrat(boss3,"boss3");
		};

		boss3.prepare = function(){
			this.vulnerableTimeCount = 0;
			this.setNewTimerHit();
		};

		boss3.setNewTimerHit = function(){
			this.isOnCombo = false;
			this.nextHit = (Math.random() * (this.TIMER_BETWEEN_HIT_MAX - this.TIMER_BETWEEN_HIT_MIN)) + this.TIMER_BETWEEN_HIT_MIN;
			this.hitCount = (Math.random() * (this.MAX_HIT - this.MIN_HIT)) + this.MIN_HIT;
		};

		boss3.onKo = function(isBoss){
			this.prepare();
		};

		boss3.endRound = function(){
			this.prepare();
		};

		boss3.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }

			if(this.vulnerableTimeCount <= 0 &&
			  (action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.super)){
				actionBack = LIST_CAPA_BOXER.dodge;
			}else{
				actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}

			return actionBack;
		};

		boss3.actionEnd = function(action,boss,dir) {
			switch(action){
				case LIST_CAPA_BOXER.preSuper:
					boss.makeAction(LIST_CAPA_BOXER.super+"_"+dir);
					break;
				case LIST_CAPA_BOXER.super:
					boss.makeAction(LIST_CAPA_BOXER.idle+"_"+dir);
					this.setNewTimerHit();
					break;
				case LIST_CAPA_BOXER.punchChest:
					if(this.hitCount > 0){
						boss.makeAction(LIST_CAPA_BOXER.punchChest);
						this.hitCount --;
					}else{
						this.vulnerableTimeCount = this.VULNERABLE_TIME;
						boss.makeAction(LIST_CAPA_BOXER.specific);
					}
					break;
				case LIST_CAPA_BOXER.dodge:
					boss.makeAction(LIST_CAPA_BOXER.punchHead);
					break;
			}
		};

		boss3.update = function(dt,boss) {
			this.nextHit -= dt;
			this.vulnerableTimeCount -= dt;

			if(this.nextHit <= 0 && !this.isOnCombo){
				this.isOnCombo = true;
				var action = (Math.random()>0.65)?LIST_CAPA_BOXER.punchChest:LIST_CAPA_BOXER.preSuper;
				action += "_"+((Math.random()>0.5)?DIR_CAPA.left:DIR_CAPA.right);
				boss.makeAction(action);
			}

			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
				this.setNewTimerHit();
				if(boss.getJsonBoss().animationName == LIST_CAPA_BOXER.specific){
					boss.makeAction(LIST_CAPA_BOXER.idle)
				}
			}
		};

		boss3.playerDodgeHit = function(action){};

		boss3.playerBlockHit = function(action){};

		boss3.init();
	/////////////////////////////////////
	
	////////////////////////////////////////
	// Boss4
		/*
		le taper, il va bloquer puis riposter, esquiver (ou block) sa serie de coup, il va danser juste apres
		que des coup dans le ventre, pendant sa danse,
		dodge son "coupchargé" du meme coté
		il va taper de temps en temps
		*/
		var boss4 = {};
		boss4.VULNERABLE_TIME = 3;//second
		boss4.TIMER_BETWEEN_HIT_MAX = 6;
		boss4.TIMER_BETWEEN_HIT_MIN = 3;
		boss4.MAX_HIT = 4;
		boss4.MIN_HIT = 2;


		boss4.init = function() {
			StratManager.registerStrat(boss4,"boss4");
		};

		boss4.prepare = function(){
			this.vulnerableTimeCount = 0;
			this.setNewTimerHit();
		};

		boss4.setNewTimerHit = function(){
			this.isOnCombo = false;
			this.playerHitted = false;
			this.nextHit = (Math.random() * (this.TIMER_BETWEEN_HIT_MAX - this.TIMER_BETWEEN_HIT_MIN)) + this.TIMER_BETWEEN_HIT_MIN;
			this.hitCount = (Math.random() * (this.MAX_HIT - this.MIN_HIT)) + this.MIN_HIT;
		};

		boss4.onKo = function(isBoss){
			this.prepare();
		};

		boss4.endRound = function(){
			this.prepare();
		};


		boss4.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }

			if(action == LIST_CAPA_BOXER.hittedHead){
				this.playerHitted = true;
			}

			if(this.vulnerableTimeCount <= 0 &&
			  (action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.super)){
				actionBack = LIST_CAPA_BOXER.block;
			}else if(this.vulnerableTimeCount > 0 ){
				if(action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.super){
					actionBack = LIST_CAPA_BOXER.hitByPunch(action);
				}else if(action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead){
					actionBack = LIST_CAPA_BOXER.block;
				}
			}
			return actionBack;
		};

		boss4.actionEnd = function(action,boss,dir) {
			switch(action){
				case LIST_CAPA_BOXER.preSuper:
					boss.makeAction(LIST_CAPA_BOXER.super+"_"+dir);
					break;
				case LIST_CAPA_BOXER.super:
					this.setNewTimerHit();
					boss.makeAction(LIST_CAPA_BOXER.idle+"_"+dir);
					break;
				case LIST_CAPA_BOXER.punchChest:
					this.setNewTimerHit();
					break;
				case LIST_CAPA_BOXER.punchHead:
					if(this.hitCount > 0){
						boss.makeAction(LIST_CAPA_BOXER.punchHead);
						this.hitCount --;
					}else if(!this.playerHitted){
						this.vulnerableTimeCount = this.VULNERABLE_TIME;
						boss.makeAction(LIST_CAPA_BOXER.specific);
					}else{
						this.setNewTimerHit();
					}
					break;
				case LIST_CAPA_BOXER.block:
					this.launchAttack(boss,true);
					break;
			}
		};

		boss4.update = function(dt,boss) {
			this.nextHit -= dt;
			this.vulnerableTimeCount -= dt;
			var bossAnim = boss.getJsonBoss();

			if(this.nextHit <= 0 && !this.isOnCombo && bossAnim.animationName != LIST_CAPA_BOXER.block){
				this.launchAttack(boss,false);
			}

			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
				this.setNewTimerHit();
				if(bossAnim.animationName == LIST_CAPA_BOXER.specific){
					boss.makeAction(LIST_CAPA_BOXER.idle)
				}
			}
		};

		boss4.launchAttack = function(boss,vulne){
			if(!this.isOnCombo){
				this.isOnCombo = true;
				var action = (Math.random()>0.3)?LIST_CAPA_BOXER.punchChest:LIST_CAPA_BOXER.preSuper; //70(punchChest) / 30(super)
				if(vulne) action = (Math.random()>0.5)?LIST_CAPA_BOXER.punchHead:action; //35(punchChest) / 15(super) / 50(punchHead)
				action += "_"+((Math.random()>0.5)?DIR_CAPA.left:DIR_CAPA.right);
				boss.makeAction(action);
			}
		}

		boss4.playerDodgeHit = function(action){};

		boss4.playerBlockHit = function(action){};

		boss4.init();
	/////////////////////////////////////
		
	////////////////////////////////////////
	// Boss5
		/*
		(ia)dodge everythings
		(player)peux bloquer ou dodge tout ses coups
		tape beaucoup et est rapide
		lui mettre un coupDodge apres sont combo (1s)
		l'enchainer avec des coups pendants x seconds
		*/
		var boss5 = {};
		boss5.VULNERABLE_TIME = 3;//second
		boss5.TIMER_BETWEEN_HIT_MAX = 0.3;
		boss5.TIMER_BETWEEN_HIT_MIN = 0.1;
		boss5.WEAK_SPOT_PERCENT = 0.15; //15% chance of weak spot


		boss5.init = function() {
			StratManager.registerStrat(boss5,"boss5");
		};

		boss5.prepare = function(){
			this.setNewTimerHit();
			this.vulnerableTimeCount = this.VULNERABLE_TIME/2;
			this.nextHit += this.vulnerableTimeCount;
		};

		boss5.setNewTimerHit = function(){
			this.nextHit = (Math.random() * (this.TIMER_BETWEEN_HIT_MAX - this.TIMER_BETWEEN_HIT_MIN)) + this.TIMER_BETWEEN_HIT_MIN;
		};

		boss5.onKo = function(isBoss){
			this.prepare();
		};

		boss5.endRound = function(){
			this.prepare();
		};

		boss5.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.super){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }

			if(bossJson.animationName == LIST_CAPA_BOXER.specific && action == LIST_CAPA_BOXER.punchDodge){
				this.vulnerableTimeCount = this.VULNERABLE_TIME;
				this.nextHit = this.VULNERABLE_TIME + this.TIMER_BETWEEN_HIT_MIN;
				actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}
			else if(this.vulnerableTimeCount <= 0 &&
			  (action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.super)){
				actionBack = LIST_CAPA_BOXER.dodge;
			}else{
				actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}

			return actionBack;
		};

		boss5.actionEnd = function(action,boss) {
			if(action == LIST_CAPA_BOXER.preSuper){
				var player = JSON.parse(c2_callFunction(C2FUNC.getJsonPlayer));
				var actionHit = LIST_CAPA_BOXER.hitByPunch(LIST_CAPA_BOXER.super);
				if(actionHit != LIST_CAPA_BOXER.nothing && player.animationName != LIST_CAPA_BOXER.dodge){
					boss.makeAction(LIST_CAPA_BOXER.super);
				}else{
					boss.makeAction(LIST_CAPA_BOXER.idle);
					this.setNewTimerHit();
				}
			}
			else{
				this.setNewTimerHit();
			}
		};

		boss5.update = function(dt,boss) {
			this.nextHit -= dt;
			this.vulnerableTimeCount -= dt;

			if(this.nextHit <= 0 && this.nextHit > -1000 && this.vulnerableTimeCount < 0){
				this.nextHit = -1000;
				var actionArray = [LIST_CAPA_BOXER.punchChest,LIST_CAPA_BOXER.punchHead];
				var action = actionArray[Math.floor(Math.random()*actionArray.length)];
				if(Math.random() > 0.9) action = LIST_CAPA_BOXER.preSuper; //10% chance super
				if(Math.random() < this.WEAK_SPOT_PERCENT) action = LIST_CAPA_BOXER.specific;
				boss.makeAction(action);
			}

			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
				if(boss.getJsonBoss().animationName == LIST_CAPA_BOXER.specific){
					boss.makeAction(LIST_CAPA_BOXER.idle);
				}
			}
		};

		boss5.playerDodgeHit = function(action,boss){};

		boss5.playerBlockHit = function(action){};

		boss5.init();
	/////////////////////////////////////
	
	////////////////////////////////////////
	// Boss6
		/*
			[weakSpot] apres chaque attaque, il va soit bloquer en haut, soit en bas, taper au bon endroit (cour timing)
			attack 1: il va partir d'un coté, et va lacher 3 "tronc d'arbre", block les ou dodge du bon coté?
			attack 2: normal attack head (only block)
			attack 2: normal attack chest (esquive only)
			apres chaque ko, +1 tronc d'arbre
			et plus forcement de weakSpot apres une attaque apres le 2eme ko (60% chance week spot)
		*/
		var boss6 = {};
		boss6.VULNERABLE_TIME = 3; //second
		boss6.TIMER_BETWEEN_TREE_FALL = 1.5; //second
		boss6.CHANCE_WEAK_SPOT = 0.6;// chance/1 to not trigger weak spot after first ko
		boss6.TIMER_WEAK_SPOT = 1.5;


		boss6.init = function() {
			StratManager.registerStrat(boss6,"boss6");	
		};

		boss6.prepare = function(){
			this.timerToHitOnWeakSpot = 0;
			this.countTree = 3;
			this.countKo = 0;
			this.vulnerableTimeCount = 1;
			this.treeIsFalling = false;
		};

		boss6.endRound = function(){
			this.vulnerableTimeCount = 1;
			this.treeIsFalling = false;
		};

		boss6.onKo = function(isBoss){
			this.countKo ++;
			this.countTree ++;
			this.timerToHitOnWeakSpot = 0.5;
			this.vulnerableTimeCount = -1000;
			this.treeIsFalling = false;
			if(!isBoss){
				c2_callFunction(C2FUNC.resetPosBoss6);
			}
		};

		boss6.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }

			if(this.vulnerableTimeCount > 0 ){
				actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}
			else if((action == LIST_CAPA_BOXER.punchHead && bossJson.animationName == LIST_CAPA_BOXER.blockDown) ||
				(action == LIST_CAPA_BOXER.punchChest && bossJson.animationName == LIST_CAPA_BOXER.blockUp)){
					this.vulnerableTimeCount = this.VULNERABLE_TIME;
					this.timerToHitOnWeakSpot = -1000;
					actionBack = LIST_CAPA_BOXER.hitByPunch(action);
			}else if((action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.punchChest) && this.vulnerableTimeCount <= 0){
				this.launchAttack(boss);
			}

			return actionBack;
		};

		boss6.actionEnd = function(action,boss,dir) {
			switch(action){
				case LIST_CAPA_BOXER.punchHead:
				case LIST_CAPA_BOXER.punchChest:
				case LIST_CAPA_BOXER.specific:
					this.treeIsFalling = false;
					if(this.countKo > 0 && Math.random()>this.CHANCE_WEAK_SPOT){
						this.launchAttack(boss);
					}else{
						this.timerToHitOnWeakSpot = this.TIMER_WEAK_SPOT;
						boss.makeAction(((Math.random()>0.5)?LIST_CAPA_BOXER.blockUp:LIST_CAPA_BOXER.blockDown));
					}
					break;
				case LIST_CAPA_BOXER.block:
				case LIST_CAPA_BOXER.blockDown:
				case LIST_CAPA_BOXER.blockUp:
					this.launchAttack(boss);
					break;
				case LIST_CAPA_BOXER.dodge:
					break;
			}
		};

		boss6.update = function(dt,boss) {
			this.vulnerableTimeCount -= dt;
			this.timerToHitOnWeakSpot -= dt;
			if(this.timerToHitOnWeakSpot < 0 && this.timerToHitOnWeakSpot > -1000){
				this.timerToHitOnWeakSpot = -1000;
				this.launchAttack(boss);
			}
			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
				this.launchAttack(boss);
			}
		};

		boss6.launchAttack = function(boss){
			if(!this.treeIsFalling && this.vulnerableTimeCount <= 0){
				var actionArray = [LIST_CAPA_BOXER.dodge,LIST_CAPA_BOXER.punchChest,LIST_CAPA_BOXER.punchHead];
				var action = actionArray[Math.floor(Math.random()*actionArray.length)];
				if(action == LIST_CAPA_BOXER.dodge) this.treeIsFalling = true;
				action += "_"+((Math.random()>0.5)?DIR_CAPA.left:DIR_CAPA.right);
				boss.makeAction(action);
			}
		};

		boss6.playerDodgeHit = function(action){};

		boss6.playerBlockHit = function(action){};

		boss6.init();
	/////////////////////////////////////
	
	////////////////////////////////////////
	// Boss 7
 		/*
		(punchChest) taper x random fois (2-8 ?) (	block or dodge) 
			peux le taper apres
		apres premier ko : 
			direcement charge super, dodge le(only)
			repart sur la strat 1 apres
		apres 2eme ko et +
			comme premier ko
			et va faire des punchHead en plus (only dodge)
		les coups normaux lui font presque pas de degat (1/2) sur 200 pv, mais le super fait beaucoup (casi ko)
		*/
		var boss7 = {};
		boss7.VULNERABLE_TIME = 1.5;//second
		boss7.TIMER_BETWEEN_HIT_MAX = 1.3;
		boss7.TIMER_BETWEEN_HIT_MIN = 0.8;
		boss7.MAX_HIT = 6;
		boss7.MIN_HIT = 2;
		boss7.KO_MIN_FOR_ADD_PUNCH = 0;
		boss7.PUNCH_HEAD_PERCENT = 0.2;

		boss7.init = function() {
			StratManager.registerStrat(boss7,"boss7");
		};

		boss7.prepare = function(){
			this.countKo = 0;
			this.lastCountKo = 0;
			this.vulnerableTimeCount = 0;
			this.setNewTimerHit();
			this.nextHit = 1.5; //start launch attack
		};

		boss7.endRound = function(){
			this.setNewTimerHit();
		};

		boss7.setNewTimerHit = function(){
			this.isOnCombo = false;
			this.nextHit = (Math.random() * (this.TIMER_BETWEEN_HIT_MAX - this.TIMER_BETWEEN_HIT_MIN)) + this.TIMER_BETWEEN_HIT_MIN;
			this.hitCount = (Math.random() * (this.MAX_HIT - this.MIN_HIT)) + this.MIN_HIT;
		};

		boss7.onKo = function(isBoss){
			if(isBoss) this.countKo ++;
			this.vulnerableTimeCount = 0;
			this.setNewTimerHit();
			this.nextHit = 1.5; //start launch attack
		};

		boss7.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.super){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.dodge){ return actionBack; }

			if(action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.super){
				if(this.vulnerableTimeCount <= 0){
					actionBack = LIST_CAPA_BOXER.dodge;
				}else if(this.vulnerableTimeCount > 0 ){
					actionBack = LIST_CAPA_BOXER.hitByPunch(action);
					this.vulnerableTimeCount = 0;
				}
			}
			
			return actionBack;
		};

		boss7.actionEnd = function(action,boss,dir) {
			switch(action){
				case LIST_CAPA_BOXER.preSuper:
					boss.makeAction(LIST_CAPA_BOXER.super+"_"+dir);
					break;
				case LIST_CAPA_BOXER.super:
					this.setNewTimerHit();
					break;
				case LIST_CAPA_BOXER.punchHead:
					this.setNewTimerHit();
					break;
				case LIST_CAPA_BOXER.punchChest:
					if(this.hitCount > 0){
						boss.makeAction(LIST_CAPA_BOXER.punchChest);
						this.hitCount --;
					}else{
						this.vulnerableTimeCount = this.VULNERABLE_TIME;
						this.setNewTimerHit();
					}
					break;
				case LIST_CAPA_BOXER.dodge:
					this.launchAttack(boss);
					break;
			}
		};

		boss7.update = function(dt,boss) {
			this.nextHit -= dt;
			this.vulnerableTimeCount -= dt;
			var bossAnim = boss.getJsonBoss();

			if(this.nextHit <= 0 && !this.isOnCombo && bossAnim.animationName != LIST_CAPA_BOXER.dodge){
				this.launchAttack(boss);
			}

			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
				this.setNewTimerHit();
				/*if(bossAnim.animationName == LIST_CAPA_BOXER.specific){
					boss.makeAction(LIST_CAPA_BOXER.idle)
				}*/
			}
		};

		boss7.launchAttack = function(boss){
			if(!this.isOnCombo){
				this.isOnCombo = true;
				var action = LIST_CAPA_BOXER.punchChest;

				if(this.countKo >= this.KO_MIN_FOR_ADD_PUNCH && Math.random() < this.PUNCH_HEAD_PERCENT){
					action = LIST_CAPA_BOXER.punchHead;
				}

				if(this.lastCountKo != this.countKo){
					this.lastCountKo = this.countKo;
					action = LIST_CAPA_BOXER.preSuper;
				}
				action += "_"+((Math.random()>0.5)?DIR_CAPA.left:DIR_CAPA.right);
				boss.makeAction(action);
			}
		}

		boss7.playerDodgeHit = function(action,boss){};

		boss7.playerBlockHit = function(action){};

		boss7.init();
	/////////////////////////////////////

	////////////////////////////////////////
	// Boss 8
		/*

		*/
		var boss8 = {};
		boss8.VULNERABLE_TIME = 1.5;//second
		boss8.VULNERABLE_TIME_PER_KILL = 0.7;//second
		boss8.TIMER_BETWEEN_MOVE_MAX = 1.5;
		boss8.TIMER_BETWEEN_MOVE_MIN = 1;
		boss8.NB_TIME_MOVE = 5;
		boss8.TIME_FOR_MOVE = 0.5;
		boss8.POS_ARRAY = {
			pos : ["left","center","right"],
			posX: [104,263,400],
			getRandom : function(){return this.pos[Math.floor(Math.random()*this.pos.length)];},
			getIdByName : function(name){for(var i in this.pos){ if(name === this.pos[i]) return i;} return -1;},
			getNameById : function(i){return this.pos[i];},
			getXById : function(i){return this.posX[i];},
			getXByName : function(name){return this.getXById(this.getIdByName(name))},
			getNameByX : function(x){for(var i =0;i < this.posX.length;i++){if(this.posX[i] === x) return this.getNameById(i);} return "none";}
		};

		boss8.init = function() {
			StratManager.registerStrat(boss8,"boss8");
		};

		boss8.prepare = function(){
			this.vulnerableTimeCount = 0;
			this.setNewTimerHit();
			this.timer = 100;
			this.callbackTimer = undefined;
			this.nextMove = 1.5; //first attack
			this.moveToList = [];
		};

		boss8.endRound = function(){
			this.prepare();
		}

		boss8.setNewTimerHit = function(){
			this.cloneKilled = 0;
			this.isOnCombo = false;
			this.isOnSuper = false;
			this.superState = -1;
			this.nextMove = (Math.random() * (this.TIMER_BETWEEN_MOVE_MAX - this.TIMER_BETWEEN_MOVE_MIN)) + this.TIMER_BETWEEN_MOVE_MIN;
		};

		boss8.onKo = function(isBoss){
			this.prepare();
		};

		boss8.userMakeAction = function(action,dir,boss) {
			var actionBack = LIST_CAPA_BOXER.nothing;
			//return actionBack;
			if(action == LIST_CAPA_BOXER.idle){ return actionBack; }
			var bossJson = boss.getJsonBoss();
			if(this.isOnSuper && (c2_callFunction(C2FUNC.isOnMove) == 1 || this.superState == 1 || this.superState == 5 || this.vulnerableTimeCount <= 0)){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.preSuper){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.super){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchChest){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.punchHead){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.dodge){ return actionBack; }
			if(bossJson.animationName == LIST_CAPA_BOXER.block){ return actionBack; }

			if(action == LIST_CAPA_BOXER.punchChest || action == LIST_CAPA_BOXER.punchDodge || action == LIST_CAPA_BOXER.punchHead || action == LIST_CAPA_BOXER.super){
				if(this.vulnerableTimeCount <= 0){
					actionBack = (this.isOnSuper)?LIST_CAPA_BOXER.block:LIST_CAPA_BOXER.dodge;
				}else if(this.vulnerableTimeCount > 0 ){
					if(this.isOnSuper){
						if(bossJson.x === this.POS_ARRAY.getXByName("center")){
							actionBack = LIST_CAPA_BOXER.block;
							this.vulnerableTimeCount = 0;
						}else{
							this.cloneKilled ++;
							this.callbackTimer = undefined;
							this.vulnerableTimeCount = 0;
							c2_callFunction(C2FUNC.bossMakeActionCenter,[LIST_CAPA_BOXER.specific+"3"]);
						}
					}else{
						actionBack = LIST_CAPA_BOXER.hitByPunch(action);
					}
	
				}
			}
			
			return actionBack;
		};

		boss8.actionEnd = function(action,boss,dir,isRealBoxer) {
			switch(action){
				case LIST_CAPA_BOXER.punchChest:
					this.timer = 0.5;
					this.callbackTimer = this.launchAttack.bind(this,boss);
					break;
				case LIST_CAPA_BOXER.punchHead:
					if(!this.isOnSuper){ this.setNewTimerHit();}
					break;
				case LIST_CAPA_BOXER.block:
					boss.makeAction(LIST_CAPA_BOXER.punchHead);
					break;
				case LIST_CAPA_BOXER.specific+"3":
					this.timer = 0.5;
					this.callbackTimer = this.launchAttack.bind(this,boss);
					break;
			}
		};

		boss8.update = function(dt,boss) {
			this.nextMove -= dt;
			this.vulnerableTimeCount -= dt;
			this.timer -= dt;

			var bossAnim = boss.getJsonBoss();

			if(this.nextMove <= 0  && this.nextMove > -1000 && !this.isOnCombo && bossAnim.animationName != LIST_CAPA_BOXER.dodge){
				this.nextMove = -1000;
				this.launchAttack(boss);
			}

			if(this.timer <= 0  && typeof(this.callbackTimer) != "undefined"){
				this.callbackTimer();
				this.callbackTimer = undefined;
			}

			if(this.vulnerableTimeCount < 0 && this.vulnerableTimeCount > -1000){
				this.vulnerableTimeCount = -1000;
			}
		};

		boss8.launchAttack = function(boss){
			if(this.isOnSuper){
				if(this.superState == 2 || this.superState == 3){
					this.superState ++;
					boss.makeAction(LIST_CAPA_BOXER.specific+"2");
					c2_callFunction(C2FUNC.nextMove,[0]);
				}else if(this.superState == 4){
					this.superState ++;
					var bossJson = boss.getJsonBoss();
					this.moveToList= [];
					if(bossJson.x === this.POS_ARRAY.getXByName("center")){

					}else if(bossJson.x === this.POS_ARRAY.getXByName("left")){
						this.moveToList.push(["center","left","right"]);
					}else if(bossJson.x === this.POS_ARRAY.getXByName("right")){
						this.moveToList.push(["left","right","center"]);
					}
					c2_callFunction(C2FUNC.nextMove,[0]);
				}
			}else if(!this.isOnCombo){
				if(Math.random() >= 0.65){
					this.launchSuper(boss);
				}else{
					boss.makeAction(LIST_CAPA_BOXER.punchHead);
				}
			}
		};

		boss8.launchSuper = function(boss){
			boss.makeAction(LIST_CAPA_BOXER.idle);
			this.isOnSuper = true;
			this.superState = 1;
			var dest = this.POS_ARRAY.getRandom();
			this.moveToList = [];
			for (var i = 0; i < this.NB_TIME_MOVE; i++) {
				this.moveToList.push(shuffle(this.POS_ARRAY.pos.slice()));
			};
			this.makeGoodMoveList(this.moveToList);
			c2_callFunction(C2FUNC.createClone);
		};

		boss8.makeGoodMoveList = function(list){
			var isOver = false;
			while(!isOver){
				if(list[0].toString() === "left,center,right"){
					list[0] = shuffle(list[0]);
					isOver = false;
					continue;
				}
				for (var i = 1; i < list.length; i++) {
					if(list[i-1].toString() === list[i].toString() || list[i].toString() === "left,center,right"){
						list[i] = shuffle(list[i]);
						isOver = false;
						break;
					}
					isOver = true;
				};	
			}
			return list;
		};

		boss8.getStrToMove = function(){return this.moveToList.splice(0, 1).toString();};

		boss8.endPrepareSuper = function(){
			if(this.superState == -1){return;}
			if(this.superState != 5){
				this.moveToList.push(["center","left","right"]);
				this.moveToList.push(["left","right","center"]);
				this.superState = 2;
			}
			this.endMoveNoAutoNext();
		};

		boss8.endMoveNoAutoNext = function(){
			if(this.superState == 5){
				c2_callFunction(C2FUNC.dCloneMoveMid,[]);
			}else{
				this.vulnerableTimeCount = this.VULNERABLE_TIME;
				this.timer = this.VULNERABLE_TIME;
				this.callbackTimer = c2_callFunction.bind(window,"BOSS8_makeActionWithCenter",["punchChest"]);
			}
		};

		boss8.endSuper = function(){
			var time = this.cloneKilled * this.VULNERABLE_TIME_PER_KILL;
			this.setNewTimerHit();
			this.vulnerableTimeCount = time;
			this.nextMove = time;
		};

		boss8.playerDodgeHit = function(action){};

		boss8.playerBlockHit = function(action){};

		boss8.init();
	/////////////////////////////////////	
/////////////////////////////////////



/////////////////////////////////////
// UTILS
	function shuffle(array) {
		var m = array.length, t, i;
		// While there remain elements to shuffle…
		while (m) {
			i = Math.floor(Math.random() * m--);
			t = array[m];
			array[m] = array[i];
			array[i] = t;
		}
		return array;
	}

	function randomIntFromInterval(min,max){
		return Math.floor(Math.random()*(max-min+1)+min);
	}
/////////////////////////////////////

/////////////////////////////////////
// object
	if(typeof(window.playtouch) != "object"){ window.playtouch = {};}
	playtouch.gameMain = new gameMain();
/////////////////////////////////////

})();

