cordova.define("cordova-plugin-playtouch-prompt-exit.promptExit", function(require, exports, module) {
var channel = require('cordova/channel');

channel.onCordovaReady.subscribe(function() {
	var TRANSLATION = {
		"back-button-exit":{
			"deu": "Möchten Sie wirklich beenden?",
			"eng": "Are you sure you want to exit ?",
			"spa": "Seguro que quieres salir ?",
			"fra": "Êtes-vous sûr de vouloir quitter ?",
			"ita": "Sei sicuro di voler uscire ?",
			"kor": "종료 하시겠습니까?",
			"por": "Você tem certeza que quer sair ?",
			"tur": "Çıkmak istediğine emin misin ?",
			"afr": "Is jy seker jy wil uitgaan ?",
			"msa": "Anda pasti untuk keluar ?",
			"nld": "Weet u zeker dat u wilt afsluiten ?",
			"rus": "Вы уверены, что хотите выйти ?",
			"vie": "Bạn có chắc bạn muốn thoát ?",
			"zho": "你确定要离开 ？",
			"zh2": "你確定要離開 ？",
			"ara": "هل أنت متأكد أنك تريد الخروج ؟",
			"hin": "क्या आप निश्चित हैं आपकी बाहर निकलने की इच्छा है ?",
			"ind": "Anda yakin ingin keluar?",
			"jpn": "本当に終了してもよろしいですか ？",
			"tha": "คุณแน่ใจหรือไม่ว่าต้องการออก",
		},
		"yes":{
			"deu": "JA",
			"eng": "YES",
			"spa": "SÍ",
			"fra": "OUI",
			"ita": "SI",
			"kor": "예",
			"por": "SIM",
			"tur": "EVET",
			"afr": "JA",
			"msa": "YA",
			"nld": "JA",
			"rus": "ДА",
			"vie": "VÂNG",
			"zho": "是",
			"zh2": "是",
			"ara": "نــعــم",
			"hin": "हाँ",
			"ind": "IYA NIH",
			"jpn": "はい",
			"tha": "ใช่",
		},
		"no":{
			"deu": "NEIN",
			"eng": "NO",
			"spa": "NO",
			"fra": "NON",
			"ita": "NO",
			"kor": "아니요",
			"por": "NÃO",
			"tur": "HAYIR",
			"afr": "GEEN",
			"msa": "TIDAK",
			"nld": "NEE",
			"rus": "НЕТ",
			"vie": "TIDAK",
			"zho": "否",
			"zh2": "否",
			"ara": "كلا",
			"hin": "नहीं",
			"ind": "TIDAK",
			"jpn": "いいえ",
			"tha": "ไม่ใช่",
		}
	};

	function langExistInTranslation(language,defaultLang){
		for(var i in TRANSLATION["back-button-exit"]){
			if(i === language){
				return language;
			}
		}
		return defaultLang;
	}

	document.addEventListener("backbutton", onBackKeyDown, false);
	function onBackKeyDown(e) {
		e.preventDefault();
		cr_setSuspended(true);
		var actualLanguage = "eng";
		try{
			if(c2_callFunction("getGameInfo") != 0){
				actualLanguage = isoLang.getGoodLanguage(JSON.parse(c2_callFunction("getGameInfo")).supportedLanguages);
			}else{
				actualLanguage = langExistInTranslation(isoLang.getFirstLanguage(), "eng");
			}
		}catch(e){actualLanguage = "eng";}
		navigator.notification.confirm(
			TRANSLATION["back-button-exit"][actualLanguage],
			function(button){
				window.saveAdNb = 0;
				cr_setSuspended(false); 
				if(button==1){navigator.app.exitApp();}
			},
			"",
			[TRANSLATION["yes"][actualLanguage],TRANSLATION["no"][actualLanguage]]
		);
	}
});

});
